Index: pjproject/trunk/pjlib/build/wince-evc4/pjlib_wince.vcp
===================================================================
--- pjproject/trunk/pjlib/build/wince-evc4/pjlib_wince.vcp	(revision 1953)
+++ pjproject/trunk/pjlib/build/wince-evc4/pjlib_wince.vcp	(revision 1964)
@@ -166,5 +166,5 @@
 CPP=clarm.exe
 # ADD BASE CPP /nologo /W3 /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "NDEBUG" /D "ARM" /D "_ARM_" /D "ARMV4" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "_LIB" /YX /O2 /M$(CECrtMT) /c
-# ADD CPP /nologo /W3 /I "../../include" /D "NDEBUG" /D "ARMV4" /D "ARM" /D "_ARM_" /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "_LIB" /YX /O2 /M$(CECrtMT) /c
+# ADD CPP /nologo /W3 /Oxt /I "../../include" /D "NDEBUG" /D "ARMV4" /D "ARM" /D "_ARM_" /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "_LIB" /YX  /M$(CECrtMT) /c
 # SUBTRACT CPP /Fr
 LIB32=link.exe -lib
@@ -644,4 +644,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -1228,4 +1229,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -1687,4 +1689,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -2632,4 +2635,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -3050,4 +3054,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -3721,4 +3726,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -4416,4 +4422,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -4848,4 +4855,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -5294,4 +5302,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -5785,4 +5794,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -6362,4 +6372,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -7184,4 +7195,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -7636,4 +7648,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -8359,4 +8372,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -8835,4 +8849,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -9245,4 +9260,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -10172,4 +10188,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -10687,4 +10704,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -11213,4 +11231,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -11663,4 +11682,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -12636,4 +12656,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -13040,4 +13061,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -13726,4 +13748,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -14182,4 +14205,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\
@@ -14878,4 +14902,5 @@
 	"..\..\include\pj\lock.h"\
 	"..\..\include\pj\log.h"\
+	"..\..\include\pj\math.h"\
 	"..\..\include\pj\os.h"\
 	"..\..\include\pj\pool.h"\