Index: pjproject/trunk/build.symbian/bld.inf
===================================================================
--- pjproject/trunk/build.symbian/bld.inf	(revision 1978)
+++ pjproject/trunk/build.symbian/bld.inf	(revision 1979)
@@ -18,4 +18,5 @@
 pjsip_ua.mmp
 pjsua_lib.mmp
+libsrtp.mmp
 
 /* Codecs */
Index: pjproject/trunk/build.symbian/libsrtp.mmp
===================================================================
--- pjproject/trunk/build.symbian/libsrtp.mmp	(revision 1979)
+++ pjproject/trunk/build.symbian/libsrtp.mmp	(revision 1979)
@@ -0,0 +1,59 @@
+TARGET		libsrtp.lib
+TARGETTYPE	lib
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+
+//
+// GCCE optimization setting
+//
+OPTION		GCCE -O2 -fno-unit-at-a-time
+
+//
+// Speex files
+//
+SOURCEPATH	..\third_party\srtp
+
+SOURCE crypto\ae_xfm\xfm.c
+SOURCE crypto\cipher\aes.c
+SOURCE crypto\cipher\aes_cbc.c
+SOURCE crypto\cipher\aes_icm.c
+SOURCE crypto\cipher\cipher.c
+SOURCE crypto\cipher\null_cipher.c
+SOURCE crypto\hash\auth.c
+SOURCE crypto\hash\hmac.c
+SOURCE crypto\hash\null_auth.c
+SOURCE crypto\hash\sha1.c
+SOURCE crypto\kernel\alloc.c
+SOURCE crypto\kernel\crypto_kernel.c
+//SOURCE crypto\kernel\err.c
+SOURCE crypto\kernel\key.c
+SOURCE crypto\math\datatypes.c
+SOURCE crypto\math\gf2_8.c
+//SOURCE crypto\math\math.c
+SOURCE crypto\math\stat.c
+SOURCE crypto\replay\rdb.c
+SOURCE crypto\replay\rdbx.c
+//SOURCE crypto\replay\ut_sim.c
+SOURCE crypto\rng\ctr_prng.c
+SOURCE crypto\rng\prng.c
+//SOURCE crypto\rng\rand_linux_kernel.c
+SOURCE crypto\rng\rand_source.c
+SOURCE pjlib\srtp_err.c
+SOURCE srtp\srtp.c
+SOURCE tables\aes_tables.c
+
+//SOURCEPATH	..\pjmedia\src\pjmedia
+
+//SOURCE transport_srtp.c
+
+//
+// Header files
+//
+SYSTEMINCLUDE	..\third_party\srtp\include
+SYSTEMINCLUDE	..\third_party\srtp\crypto\include
+SYSTEMINCLUDE	..\third_party\build\srtp
+SYSTEMINCLUDE	..\pjlib\include 
+
+SYSTEMINCLUDE	\epoc32\include 
+SYSTEMINCLUDE	\epoc32\include\libc
Index: pjproject/trunk/build.symbian/pjlib_util.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 1978)
+++ pjproject/trunk/build.symbian/pjlib_util.mmp	(revision 1979)
@@ -30,4 +30,5 @@
 // PJLIB-UTIL files
 //
+SOURCE	base64.c
 SOURCE	crc32.c
 SOURCE	dns.c
Index: pjproject/trunk/build.symbian/pjmedia.mmp
===================================================================
--- pjproject/trunk/build.symbian/pjmedia.mmp	(revision 1978)
+++ pjproject/trunk/build.symbian/pjmedia.mmp	(revision 1979)
@@ -70,4 +70,5 @@
 SOURCE		transport_ice.c
 SOURCE		transport_udp.c
+SOURCE		transport_srtp.c
 SOURCE		wav_player.c
 SOURCE		wav_playlist.c
@@ -93,4 +94,7 @@
 SYSTEMINCLUDE	..\pjlib-util\include 
 SYSTEMINCLUDE	..\pjnath\include 
+SYSTEMINCLUDE	..\third_party\srtp\include
+SYSTEMINCLUDE	..\third_party\srtp\crypto\include
+SYSTEMINCLUDE	..\third_party\build\srtp
 
 SYSTEMINCLUDE	\epoc32\include
Index: pjproject/trunk/build.symbian/symbian_ua.mmp
===================================================================
--- pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1978)
+++ pjproject/trunk/build.symbian/symbian_ua.mmp	(revision 1979)
@@ -32,11 +32,11 @@
 	LIBRARY		pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
 	LIBRARY		pjnath.lib pjlib_util.lib pjlib.lib
-	LIBRARY		symbian_audio.lib
-	LIBRARY		libgsmcodec.lib
+	LIBRARY		symbian_audio.lib libsrtp.lib
+	LIBRARY		libgsmcodec.lib libspeexcodec.lib
 #else
 	STATICLIBRARY	pjsua_lib.lib pjsip_ua.lib
 	STATICLIBRARY	pjsip_simple.lib pjsip.lib pjsdp.lib pjmedia.lib
 	STATICLIBRARY	pjnath.lib pjlib_util.lib pjlib.lib
-	STATICLIBRARY	symbian_audio.lib
+	STATICLIBRARY	symbian_audio.lib libsrtp.lib
 	STATICLIBRARY	libgsmcodec.lib libspeexcodec.lib
 #endif
Index: pjproject/trunk/pjlib/include/pj/config_site_sample.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1978)
+++ pjproject/trunk/pjlib/include/pj/config_site_sample.h	(revision 1979)
@@ -46,5 +46,5 @@
 
 	/* SRTP has not been ported to Symbian yet */
-#   define PJMEDIA_HAS_SRTP			0
+#   define PJMEDIA_HAS_SRTP			1
 
     /* Disable these */
Index: pjproject/trunk/pjsip-apps/src/symbian_ua/ua.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/symbian_ua/ua.cpp	(revision 1978)
+++ pjproject/trunk/pjsip-apps/src/symbian_ua/ua.cpp	(revision 1979)
@@ -78,4 +78,8 @@
 #define USE_ICE		1
 
+//
+// Use SRTP?
+//
+#define USE_SRTP 	PJSUA_DEFAULT_USE_SRTP
 
 //
@@ -290,4 +294,7 @@
     cfg.max_calls = 2;
     cfg.thread_cnt = 0; // Disable threading on Symbian
+    cfg.use_srtp = USE_SRTP;
+    cfg.srtp_secure_signaling = 0;
+    
     cfg.cb.on_incoming_call = &on_incoming_call;
     cfg.cb.on_call_media_state = &on_call_media_state;
Index: pjproject/trunk/pjsip-apps/src/symbian_ua_gui/src/symbian_ua.cpp
===================================================================
--- pjproject/trunk/pjsip-apps/src/symbian_ua_gui/src/symbian_ua.cpp	(revision 1978)
+++ pjproject/trunk/pjsip-apps/src/symbian_ua_gui/src/symbian_ua.cpp	(revision 1979)
@@ -27,4 +27,5 @@
 #define SIP_PORT	5060
 #define USE_ICE		0
+#define USE_SRTP	PJSUA_DEFAULT_USE_SRTP
 
 static RSocketServ aSocketServer;
@@ -303,6 +304,6 @@
     cfg.max_calls = 2;
     cfg.thread_cnt = 0; // Disable threading on Symbian
-    //cfg.use_srtp = 0;
-    //cfg.srtp_secure_signaling = 0;
+    cfg.use_srtp = USE_SRTP;
+    cfg.srtp_secure_signaling = 0;
 
     cfg.cb.on_incoming_call = &on_incoming_call;